/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of SocketAlarm.xs. Do not edit this file, edit SocketAlarm.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "SocketAlarm.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define NEED_mg_findext
#include "ppport.h"

#include <stdint.h>
#include <stdbool.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>
#include <signal.h>
#include <poll.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <assert.h>
#include <stdio.h>
#include <string.h>

#define AUTOCREATE 1
#define OR_DIE 2

struct socketalarm;

#include "SocketAlarm_util.h"
#include "SocketAlarm_action.h"
#include "pollfd_rbhash.h"
#include "SocketAlarm_watcher.h"

#define EVENT_SHUT      0x01
#define EVENT_EOF       0x02
#define EVENT_CLOSE     0x04
#define EVENT_IN        0x08
#define EVENT_PRI       0x10

#ifdef POLLRDHUP
#define EVENT_DEFAULTS EVENT_SHUT
#else
#define EVENT_DEFAULTS (EVENT_SHUT|EVENT_EOF)
#endif

struct socketalarm {
   int list_ofs;      // position within watch_list, initially -1 until activated
   int watch_fd;
   dev_t watch_fd_dev;
   ino_t watch_fd_ino;
   int event_mask;
   int action_count;
   SV *owner;
   AV *actions_av;    // lazy-built
   bool unwaitable;         //
   int cur_action;          // used during execution
   struct timespec wake_ts; //
   struct action actions[];
};

static void socketalarm_exec_actions(struct socketalarm *sa);

#include "SocketAlarm_util.c"
#include "SocketAlarm_action.c"
#include "SocketAlarm_watcher.c"

struct socketalarm *
socketalarm_new(int watch_fd, struct stat *statbuf, int event_mask, SV **action_spec, size_t spec_count) {
   size_t n_actions= 0, aux_len= 0, len_before_aux;
   struct socketalarm *self= NULL;

   parse_actions(action_spec, spec_count, NULL, &n_actions, NULL, &aux_len);
   // buffer needs aligned to pointer, which sizeof(struct action) is not guaranteed to be
   len_before_aux= sizeof(struct socketalarm) + n_actions * sizeof(struct action);
   len_before_aux += sizeof(void*)-1;
   len_before_aux &= ~(sizeof(void*)-1);
   self= (struct socketalarm *) safecalloc(1, len_before_aux + aux_len);
   // second call should succeed, because we gave it back it's own requested buffer sizes.
   // could fail if user did something evil like a tied scalar that changes length...
   if (!parse_actions(action_spec, spec_count, self->actions, &n_actions, ((char*)self) + len_before_aux, &aux_len))
      croak("BUG: buffers not large enough for parse_actions");
   // If user requests EVENT_SHUT and not available on the platform, warn and downgrade to EVENT_EOF
   if (!(EVENT_DEFAULTS & EVENT_SHUT) && (event_mask & EVENT_SHUT) && !(event_mask & EVENT_EOF)) {
      SV *warned= get_sv("IO::SocketAlarm::_warned_EVENT_SHUT_unavail", GV_ADD);
      if (!SvTRUE(warned)) {
         warn("IO::SocketAlarm EVENT_SHUT is not available on this platform, using EVENT_EOF instead");
         sv_setsv(warned, &PL_sv_yes);
      }
      event_mask |= EVENT_EOF;
   }
   self->watch_fd= watch_fd;
   self->watch_fd_dev= statbuf->st_dev;
   self->watch_fd_ino= statbuf->st_ino;
   self->event_mask= event_mask;
   self->actions_av= NULL;
   self->action_count= n_actions;
   self->list_ofs= -1; // initially not in the watch list
   self->owner= NULL;
   return self;
}

void socketalarm_exec_actions(struct socketalarm *self) {
   bool resume= self->cur_action >= 0;
   struct timespec now_ts= { 0, -1 };
   if (!resume)
      self->cur_action= 0;
   while (self->cur_action < self->action_count) {
      if (!execute_action(self->actions + self->cur_action, resume, &now_ts, self))
         break;
      resume= false;
      ++self->cur_action;
   }
}

static void socketalarm__build_actions(struct socketalarm *self) {
   Size_t i;
   if (!self->actions_av) {
      self->actions_av= newAV();
      av_extend(self->actions_av, self->action_count-1);
      for (i= 0; i < self->action_count; i++) {
         AV *act_spec= newAV();
         inflate_action(self->actions+i, act_spec);
         SvREADONLY_on((SV*) act_spec);
         av_push(self->actions_av, newRV_noinc((SV*) act_spec));
      }
      SvREADONLY_on((SV*) self->actions_av);
   }
}

void socketalarm_free(struct socketalarm *sa) {
   // Must remove the socketalarm from the active list, if present
   watch_list_remove(sa);
   // Release reference to lazy-built action AV
   if (sa->actions_av)
      SvREFCNT_dec((SV*) sa->actions_av);
   // was allocated as one chunk
   Safefree(sa);
}

/* Return an SV array of an AV.
 * Returns NULL if it wasn't an AV or arrayref.
 */
static SV** unwrap_array(SV *array, SSize_t *len_out) {
   AV *av;
   SV **vec;
   SSize_t n;
   if (array && SvTYPE(array) == SVt_PVAV)
      av= (AV*) array;
   else if (array && SvROK(array) && SvTYPE(SvRV(array)) == SVt_PVAV)
      av= (AV*) SvRV(array);
   else
      return NULL;
   n= av_count(av);
   vec= AvARRAY(av);
   /* tied arrays and non-allocated empty arrays return NULL */
   if (!vec) {
      if (n == 0) /* don't return a NULL for an empty array, but doesn't need to be a real pointer */
         vec= (SV**) 8;
      else {
         /* in case of a tied array, extract the elements into a temporary buffer */
         SSize_t i;
         Newx(vec, n, SV*);
         SAVEFREEPV(vec);
         for (i= 0; i < n; i++) {
            SV **el= av_fetch(av, i, 0);
            vec[i]= el? *el : NULL;
         }
      }
   }
   if (len_out) *len_out= n;
   return vec;
}

/*------------------------------------------------------------------------------------
 * Definitions of Perl MAGIC that attach C structs to Perl SVs
 */

// destructor for Watch objects
static int socketalarm_magic_free(pTHX_ SV* sv, MAGIC* mg) {
   if (mg->mg_ptr) {
      socketalarm_free((struct socketalarm*) mg->mg_ptr);
      mg->mg_ptr= NULL;
   }
   return 0; // ignored anyway
}
#ifdef USE_ITHREADS
static int socketalarm_magic_dup(pTHX_ MAGIC *mg, CLONE_PARAMS *param) {
   croak("This object cannot be shared between threads");
   return 0;
};
#else
#define socketalarm_magic_dup 0
#endif

// magic table for Watch objects
static MGVTBL socketalarm_magic_vt= {
   0, /* get */
   0, /* write */
   0, /* length */
   0, /* clear */
   socketalarm_magic_free,
   0, /* copy */
   socketalarm_magic_dup
#ifdef MGf_LOCAL
   ,0
#endif
};

// Return the socketalarm that was attached to a perl Watch object via MAGIC.
// The 'obj' should be a reference to a blessed magical SV.
static struct socketalarm*
get_magic_socketalarm(SV *obj, int flags) {
   SV *sv;
   MAGIC* magic;

   if (!sv_isobject(obj)) {
      if (flags & OR_DIE)
         croak("Not an object");
      return NULL;
   }
   sv= SvRV(obj);
   if (SvMAGICAL(sv)) {
      /* Iterate magic attached to this scalar, looking for one with our vtable */
      if ((magic= mg_findext(sv, PERL_MAGIC_ext, &socketalarm_magic_vt)))
         /* If found, the mg_ptr points to the fields structure. */
         return (struct socketalarm*) magic->mg_ptr;
   }
   if (flags & OR_DIE)
      croak("Object lacks 'struct TreeRBXS_item' magic");
   return NULL;
}

static void attach_magic_socketalarm(SV *obj_inner_sv, struct socketalarm *sa) {
   MAGIC *magic;
   if (sa->owner)
      croak("BUG: already attached to perl object");
   sa->owner= obj_inner_sv;
   magic= sv_magicext((SV*) sa->owner, NULL, PERL_MAGIC_ext, &socketalarm_magic_vt, (const char*) sa, 0);
#ifdef USE_ITHREADS
   magic->mg_flags |= MGf_DUP;
#else
   (void)magic; // suppress 'unused' warning
#endif
}

// Return existing Watch object, or create a new one.
// Returned SV has a non-mortal refcount, which is what the typemap
// wants for returning a "struct socketalarm*" to perl-land
static SV* wrap_socketalarm(struct socketalarm *sa) {
   SV *obj;
   HV *hv;
   // Since this is used in typemap, handle NULL gracefully
   if (!sa)
      return &PL_sv_undef;
   // If there is already a node object, return a new reference to it.
   if (sa->owner)
      return newRV_inc((SV*) sa->owner);
   // else create a node object
   hv= newHV();
   obj= newRV_noinc((SV*) hv);
   sv_bless(obj, gv_stashpv("IO::SocketAlarm", GV_ADD));
   attach_magic_socketalarm((SV*) hv, sa);
   return obj;
}

#define EXPORT_ENUM(x) newCONSTSUB(stash, #x, new_enum_dualvar(aTHX_ x, newSVpvs_share(#x)))
static SV * new_enum_dualvar(pTHX_ IV ival, SV *name) {
   SvUPGRADE(name, SVt_PVNV);
   SvIV_set(name, ival);
   SvIOK_on(name);
   SvREADONLY_on(name);
   return name;
}

/*------------------------------------------------------------------------------------
 * Perl API
 */

#line 289 "SocketAlarm.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 433 "SocketAlarm.c"

XS_EUPXS(XS_IO__SocketAlarm__init_socketalarm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm__init_socketalarm)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, sock_sv, eventmask_sv, actions_sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	SV *	sock_sv = ST(1)
;
	SV *	eventmask_sv = ST(2)
;
	SV *	actions_sv = ST(3)
;
#line 288 "SocketAlarm.xs"
      int sock_fd= fileno_from_sv(sock_sv);
      int eventmask= EVENT_DEFAULTS;
      struct stat statbuf;
      struct socketalarm *sa;
      SV **action_list= NULL;
      SSize_t n_actions= 0;
#line 459 "SocketAlarm.c"
#line 295 "SocketAlarm.xs"
      if (!sv_isobject(self))
         croak("Not an object");
      if ((sa= get_magic_socketalarm(self, 0)))
         croak("Already initialized");
      if (!(sock_fd >= 0 && fstat(sock_fd, &statbuf) == 0 && S_ISSOCK(statbuf.st_mode)))
         croak("Not an open socket");
      if (eventmask_sv && SvOK(eventmask_sv))
         eventmask= SvIV(eventmask_sv);
      if (actions_sv && SvOK(actions_sv)) {
         action_list= unwrap_array(actions_sv, &n_actions);
         if (!action_list)
            croak("Actions must be an arrayref (or undefined)");
      }
      sa= socketalarm_new(sock_fd, &statbuf, eventmask, action_list, n_actions);
      attach_magic_socketalarm(SvRV(self), sa);
      XSRETURN(1); // return $self
#line 477 "SocketAlarm.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__SocketAlarm_socket); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm_socket)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "alarm");
    {
	struct socketalarm *	alarm;
	int	RETVAL;
	dXSTARG;

    alarm= get_magic_socketalarm(ST(0), OR_DIE)
;
#line 316 "SocketAlarm.xs"
      RETVAL= alarm->watch_fd;
#line 499 "SocketAlarm.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__SocketAlarm_events); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm_events)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "alarm");
    {
	struct socketalarm *	alarm;
	int	RETVAL;
	dXSTARG;

    alarm= get_magic_socketalarm(ST(0), OR_DIE)
;
#line 324 "SocketAlarm.xs"
      RETVAL= alarm->event_mask;
#line 522 "SocketAlarm.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__SocketAlarm_actions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm_actions)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "alarm");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	struct socketalarm *	alarm;

    alarm= get_magic_socketalarm(ST(0), OR_DIE)
;
#line 332 "SocketAlarm.xs"
      if (!alarm->actions_av);
         socketalarm__build_actions(alarm);
      ST(0)= sv_2mortal(newRV_inc((SV*) alarm->actions_av));
      XSRETURN(1);
#line 548 "SocketAlarm.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__SocketAlarm_action_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm_action_count)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "alarm");
    {
	struct socketalarm *	alarm;
	int	RETVAL;
	dXSTARG;

    alarm= get_magic_socketalarm(ST(0), OR_DIE)
;
#line 341 "SocketAlarm.xs"
      RETVAL= alarm->action_count;
#line 570 "SocketAlarm.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__SocketAlarm_cur_action); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm_cur_action)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "alarm");
    {
	struct socketalarm *	alarm;
	int	RETVAL;
	dXSTARG;

    alarm= get_magic_socketalarm(ST(0), OR_DIE)
;
#line 349 "SocketAlarm.xs"
      watch_list_item_get_status(alarm, &RETVAL);
#line 593 "SocketAlarm.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__SocketAlarm_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "alarm");
    {
	struct socketalarm *	alarm;
	bool	RETVAL;

    alarm= get_magic_socketalarm(ST(0), OR_DIE)
;
#line 357 "SocketAlarm.xs"
      RETVAL= watch_list_add(alarm);
#line 615 "SocketAlarm.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__SocketAlarm_cancel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm_cancel)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "alarm");
    {
	struct socketalarm *	alarm;
	bool	RETVAL;

    alarm= get_magic_socketalarm(ST(0), OR_DIE)
;
#line 365 "SocketAlarm.xs"
      RETVAL= watch_list_remove(alarm);
#line 636 "SocketAlarm.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__SocketAlarm_stringify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm_stringify)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "alarm");
    {
	struct socketalarm *	alarm;
	SV *	RETVAL;

    alarm= get_magic_socketalarm(ST(0), OR_DIE)
;
#line 373 "SocketAlarm.xs"
      SV *out= sv_2mortal(newSVpvn("",0));
      Size_t i;
#line 658 "SocketAlarm.c"
#line 376 "SocketAlarm.xs"
      sv_catpvf(out, "watch fd: %d\n", alarm->watch_fd);
      sv_catpvf(out, "event mask:%s%s\n",
         alarm->event_mask & EVENT_SHUT? " SHUT":"",
         alarm->event_mask & EVENT_CLOSE? " CLOSE":""
      );
      sv_catpv(out, "actions:\n");
      for (i= 0; i < alarm->action_count; i++) {
         char buf[256];
         snprint_action(buf, sizeof(buf), alarm->actions+i);
         sv_catpvf(out, "%4d: %s\n", (int)i, buf);
      }
      SvREFCNT_inc(out);
      RETVAL= out;
#line 673 "SocketAlarm.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__SocketAlarm__terminate_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm__terminate_all)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 395 "SocketAlarm.xs"
      shutdown_watch_thread();
#line 692 "SocketAlarm.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IO__SocketAlarm__Util_socketalarm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm__Util_socketalarm)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "sock_sv, ...");
    {
	SV *	sock_sv = ST(0)
;
	struct socketalarm *	RETVAL;
#line 403 "SocketAlarm.xs"
      int sock_fd= fileno_from_sv(sock_sv);
      int eventmask= EVENT_DEFAULTS;
      int action_ofs= 1;
      struct stat statbuf;
#line 714 "SocketAlarm.c"
#line 408 "SocketAlarm.xs"
      if (!(sock_fd >= 0 && fstat(sock_fd, &statbuf) == 0 && S_ISSOCK(statbuf.st_mode)))
         croak("Not an open socket");
      if (items > 1) {
         // must either be a scalar, a scalar followed by actions specs, or action specs
         if (SvOK(ST(1)) && looks_like_number(ST(1))) {
            eventmask= SvIV(ST(1));
            action_ofs++;
         }
      }
      RETVAL= socketalarm_new(sock_fd, &statbuf, eventmask, &(ST(action_ofs)), items - action_ofs);
      watch_list_add(RETVAL);
#line 727 "SocketAlarm.c"
	{
	    SV * RETVALSV;
    RETVALSV= wrap_socketalarm(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__SocketAlarm__Util_is_socket); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm__Util_is_socket)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd_sv");
    {
	SV *	fd_sv = ST(0)
;
	bool	RETVAL;
#line 426 "SocketAlarm.xs"
      int fd= fileno_from_sv(fd_sv);
      struct stat statbuf;
#line 752 "SocketAlarm.c"
#line 429 "SocketAlarm.xs"
      RETVAL= fd >= 0 && fstat(fd, &statbuf) == 0 && S_ISSOCK(statbuf.st_mode);
#line 755 "SocketAlarm.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__SocketAlarm__Util_get_fd_table_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm__Util_get_fd_table_str)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "max_fd=1024");
    {
	int	max_fd;
	SV *	RETVAL;

	if (items < 1)
	    max_fd = 1024;
	else {
	    max_fd = (int)SvIV(ST(0))
;
	}
#line 437 "SocketAlarm.xs"
      SV *out= newSVpvn("",0);
      size_t avail= 0, needed= 1023;
#line 781 "SocketAlarm.c"
#line 440 "SocketAlarm.xs"
      // FD status could change between calls, changing the length requirement, so loop.
      // 'avail' count includes the NUL byte, and 'needed' does not.
      while (avail <= needed) {
         sv_grow(out, needed+1);
         avail= needed+1;
         needed= snprint_fd_table(SvPVX(out), avail, max_fd);
      }
      SvCUR_set(out, needed);
      RETVAL= out;
#line 792 "SocketAlarm.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IO__SocketAlarm__Util__poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IO__SocketAlarm__Util__poll)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, events, timeout");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	fd = (int)SvIV(ST(0))
;
	SV *	events = ST(1)
;
	int	timeout = (int)SvIV(ST(2))
;
#line 461 "SocketAlarm.xs"
      int ret;
      struct pollfd pollbuf;
#line 818 "SocketAlarm.c"
#line 464 "SocketAlarm.xs"
      pollbuf.fd= fd;
      pollbuf.events= SvIV(events);
      pollbuf.revents= 0;
      ret= poll(&pollbuf, 1, timeout);
      EXTEND(SP, 2);
      PUSHs(sv_2mortal(newSViv(ret)));
      PUSHs(sv_2mortal(newSViv(ret < 0? errno : ret > 0? pollbuf.revents : 0)));
#line 827 "SocketAlarm.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_IO__SocketAlarm); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_IO__SocketAlarm)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("IO::SocketAlarm::_init_socketalarm", XS_IO__SocketAlarm__init_socketalarm);
        newXS_deffile("IO::SocketAlarm::socket", XS_IO__SocketAlarm_socket);
        newXS_deffile("IO::SocketAlarm::events", XS_IO__SocketAlarm_events);
        newXS_deffile("IO::SocketAlarm::actions", XS_IO__SocketAlarm_actions);
        newXS_deffile("IO::SocketAlarm::action_count", XS_IO__SocketAlarm_action_count);
        newXS_deffile("IO::SocketAlarm::cur_action", XS_IO__SocketAlarm_cur_action);
        newXS_deffile("IO::SocketAlarm::start", XS_IO__SocketAlarm_start);
        newXS_deffile("IO::SocketAlarm::cancel", XS_IO__SocketAlarm_cancel);
        newXS_deffile("IO::SocketAlarm::stringify", XS_IO__SocketAlarm_stringify);
        newXS_deffile("IO::SocketAlarm::_terminate_all", XS_IO__SocketAlarm__terminate_all);
        newXS_deffile("IO::SocketAlarm::Util::socketalarm", XS_IO__SocketAlarm__Util_socketalarm);
        newXS_deffile("IO::SocketAlarm::Util::is_socket", XS_IO__SocketAlarm__Util_is_socket);
        newXS_deffile("IO::SocketAlarm::Util::get_fd_table_str", XS_IO__SocketAlarm__Util_get_fd_table_str);
        newXS_deffile("IO::SocketAlarm::Util::_poll", XS_IO__SocketAlarm__Util__poll);

    /* Initialisation Section */

#line 477 "SocketAlarm.xs"
   HV* stash= gv_stashpvn("IO::SocketAlarm::Util", 21, GV_ADD);
   EXPORT_ENUM(EVENT_SHUT);
   EXPORT_ENUM(EVENT_EOF);
   EXPORT_ENUM(EVENT_IN);
   EXPORT_ENUM(EVENT_PRI);
   EXPORT_ENUM(EVENT_CLOSE);
   EXPORT_ENUM(POLLIN);
   EXPORT_ENUM(POLLOUT);
   EXPORT_ENUM(POLLPRI);
   EXPORT_ENUM(POLLERR);
   EXPORT_ENUM(POLLHUP);
#ifdef POLLRDHUP
   EXPORT_ENUM(POLLRDHUP);
#endif
   EXPORT_ENUM(POLLNVAL);

#line 895 "SocketAlarm.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
